/* stampa_numeri.c */

/* Direttive */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define ROW_LENGTH 256
#define N 100


/* Prototipi delle procedure secondarie e definizione di tipi */

void InterpretaLineaComando (int argc, char *argv[], char *filemosse);

/* Carica dal file filedati nel vettore V di lunghezza n i numeri da stampare */
void CaricaVettoreInteri (char *filedati, int *V, int n);

/* Stampa il vettore di interi V di lunghezza n */
void StampaVettoreInteri (int *V, int n);


/* Programma principale */
int main (int argc, char *argv[])
{
  char filedati[ROW_LENGTH];
  int V[N+1];


  /* Legge da linea di comando il file che contiene i dati */
  InterpretaLineaComando(argc,argv,filedati);

  /* Legge la lunghezze e gli elementi del vettore */
  CaricaVettoreInteri(filedati,V,N);

  /* Stampa il vettore ordinato */
  StampaVettoreInteri(V,N);

  return EXIT_SUCCESS;
}


/* Definizione delle procedure secondarie */

/* Legge dalla linea di comando il file che contiene i dati */
void InterpretaLineaComando (int argc, char *argv[], char *filedati)
{
  if (argc != 2)
  {
    fprintf(stderr,"Errore nella linea di comando!\n");
    exit(EXIT_FAILURE);
  }

  strcpy(filedati,argv[1]);
}


/* Carica dal file filedati nel vettore V di lunghezza n i numeri da stampare */
void CaricaVettoreInteri (char *filedati, int *V, int n)
{
  FILE *fp;
  int i;


  fp = fopen(filedati,"r");
  if (fp == NULL)
  {
    fprintf(stderr,"Errore nell'apertura del file %s!\n",filedati);
    exit(EXIT_FAILURE);
  }

  for (i = 1; i <= n; i++)
    if (fscanf(fp,"%d",&V[i]) != 1)
    {
      fprintf(stderr,"Errore nella lettura del file %s!\n",filedati);
      exit(EXIT_FAILURE);
    }

  fclose(fp);
}


/* Stampa il vettore di interi V di lunghezza n */
void StampaVettoreInteri (int *V, int n)
{
  int i;

  for (i = 1; i <= n; i++)
    printf("%d ",V[i]);
}
